module Scanner where

import Data.Char

skipWhiteSpaces :: String -> String
skipWhiteSpaces (c:cs) | isSpace c   = skipWhiteSpaces cs
skipWhiteSpaces cs                   = cs


{-- this is a function to split a string by either spaces or '(' or ')'
    whereas parantheses will become tokens  --}
tokenize :: String -> [String]
tokenize "" = []
tokenize text = undefined  -- TODO

nextWordAndRest :: String -> (String, String)
nextWordAndRest text = nextWordAndRest' (skipWhiteSpaces text) ""
    where
        nextWordAndRest' :: String -> String -> (String, String)
        nextWordAndRest' []           word              = (reverse word, [])
        nextWordAndRest' txt@('(':_)  word              = (reverse word, txt)
        nextWordAndRest' txt@(')':_)  word              = (reverse word, txt)
        nextWordAndRest' (s:rest)     word | isSpace s  = (reverse word, rest)
        nextWordAndRest' (c:rest)     word              = nextWordAndRest' rest (c:word)


{-- this is a function to check a list of tokens
    if all the open bracket are also closed --}
areBracketsBalanced  :: [String] -> Bool
areBracketsBalanced  tkns = undefined  -- TODO
